package com.huimv.video.dhicc.test.request;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.huimv.video.dhicc.test.config.OauthConfigBaseInfo;
import com.huimv.video.dhicc.test.constant.Constant;
import com.huimv.video.dhicc.test.utils.HttpURLConnectionUtil;
import com.huimv.video.dhicc.test.utils.HttpsURLConnectionUtil;
import com.huimv.video.dhicc.test.utils.UrlUtil;
import lombok.Data;

import java.util.HashMap;
import java.util.Map;

@Data
public class ClientAllEventRecordRequestSg extends BaseRequest<Object>{


    private String alarmStartDateString;

    private String alarmEndDateString;

    private Integer pageNum;

    private Integer pageSize;

    private Integer alarmType;

    private Integer dbType;

    private Integer deviceCategory;

    private String[] nodeCodeList;


    public ClientAllEventRecordRequestSg() {
    }

    public ClientAllEventRecordRequestSg(OauthConfigBaseInfo oauthConfigBaseInfo) {
        super(oauthConfigBaseInfo, Constant.HTTP_POST, oauthConfigBaseInfo.getHttpConfigInfo().getPrefixUrl() + Constant.CHANNEL_URL_ALARM_RECORD, true);
    }

    @Override
    public Object doAction() {
        //重置url信息，替换版本号
        this.setUrl(UrlUtil.dealVersion(this.getUrl()));
        //设置请求参数
        setBody();
        //发送请求
        String res = isEnableHttpTest() ? HttpURLConnectionUtil.doPost(this.getUrl(), this.getBody(), this.getHeader()) : HttpsURLConnectionUtil.doPost(this.getUrl(), this.getBody(), this.getHeader());
        System.out.println(res);
        //获取响应
        JSONObject jsonObject = JSONObject.parseObject(res);
        Object data = jsonObject.get("data");
        // PersonListResponseSg devicePageResponse = JSON.parseObject(res, PersonListResponseSg.class);

        return data;
    }

    private void setBody() {
        //设置请求参数
        Map<String, Object> map = new HashMap<>();
        map.put("alarmStartDateString", this.alarmStartDateString);
        map.put("alarmEndDateString", this.alarmEndDateString);
        map.put("alarmType", this.alarmType);
        map.put("dbType", this.dbType);
        map.put("deviceCategory", this.deviceCategory);
        map.put("nodeCodeList", this.nodeCodeList);
        map.put("pageNum", this.pageNum);
        map.put("pageSize", this.pageSize);
        this.setBody(JSON.toJSONString(map));

    }


    public boolean isEnableHttpTest() {
        return super.getOauthConfigBaseInfo().getHttpConfigInfo().isEnableHttpTest();
    }
}
